# {{ ansible_managed }}

{%- for vhost,vhost_config in user.value.users_apache_virtual_hosts.items() %}

# {{ vhost_config.users_apache_server_name }} port 80
<VirtualHost *:80>
  ServerName {{ vhost_config.users_apache_server_name }}
  {%- if vhost_config.users_apache_server_aliases is defined %}
  ServerAlias{% for alias in vhost_config.users_apache_server_aliases %} {{ alias }}{% endfor %}
  {%- endif %}
  <If "%{HTTP_HOST} == '{{ vhost_config.users_apache_server_name }}'">
    RedirectMatch 301 ^(?!/\.well-known/acme-challenge/).* https://{{ vhost_config.users_apache_server_name }}$0
  </If>
  {%- if vhost_config.users_apache_server_aliases is defined %}
    {%- for alias in vhost_config.users_apache_server_aliases %}
  <ElseIf "%{HTTP_HOST} == '{{ alias }}'">
    RedirectMatch 301 ^(?!/\.well-known/acme-challenge/).* https://{{ alias }}$0
  </ElseIf>
    {%- endfor %}
  {%- endif %}
  <Else>
    RedirectMatch 301 ^(?!/\.well-known/acme-challenge/).* https://{{ vhost_config.users_apache_server_name }}$0
  </Else>
</VirtualHost>
# {{ vhost_config.users_apache_server_name }} port 443
# {{ user.value.users_home | default(users_basedir + '/' + user.key) }}/{{ users_sites_dir }}/{{ vhost }}
<IfModule md_module>
  MDomain {{ vhost_config.users_apache_server_name }}
</IfModule>
<VirtualHost *:443>
  ServerName {{ vhost_config.users_apache_server_name }}
  {%- if vhost_config.users_apache_server_aliases is defined %}
  ServerAlias{% for alias in vhost_config.users_apache_server_aliases %} {{ alias }}{% endfor %}
  {%- endif %}
  {%- if users_apache_chroot_suexec and "suexec" in users_apache_modules_loaded %}
  <IfModule suexec_module>
    SuexecUserGroup {{ user.key }} {{ user.value.users_group | default(user.key) }}
  </IfModule>
  {%- endif %}
  {%- if "mpm_itk" in users_apache_modules_loaded %}
  <IfModule mpm_itk_module>
    AssignUserID {{ user.key }}
    MaxClientsVHost {{ apache_mpm_itk_max_clients_vhost | default('50') }}
  </IfModule>
  {%- endif %}
  {%- if users_cert is defined %}
  SSLEngine on
    {%- if users_cert == "user" %}
  SSLCertificateFile            {{ le_dir }}/{{ user.key }}.{{ inventory_hostname }}.cert.pem
  SSLCertificateKeyFile         {{ le_dir }}/{{ user.key }}.{{ inventory_hostname }}.key.pem
  SSLCertificateChainFile       {{ le_dir }}/{{ user.key }}.{{ inventory_hostname }}.ca.pem
    {%- endif %}
    {%- if users_cert == "vhost" %}
  SSLCertificateFile            {{ le_dir }}/{{ vhost_config.users_apache_server_name }}.cert.pem
  SSLCertificateKeyFile         {{ le_dir }}/{{ vhost_config.users_apache_server_name }}.key.pem
  SSLCertificateChainFile       {{ le_dir }}/{{ vhost_config.users_apache_server_name }}.ca.pem
    {%- endif %}
  {%- endif %}
  {%- if user.value.users_email is defined and user.value.users_email != "" %}
  ServerAdmin "{{ user.value.users_email }}"
  {%- endif %}
  {%- if users_apache_env is defined or vhost_config.users_apache_env is defined %}
  <IfModule env_module>
    {%- if users_apache_env is defined %}
      {%- for setenv in users_apache_env %}
        {%- if ( setenv.set is not defined ) or ( setenv.set is defined and setenv.set ) %}
    SetEnv {{ setenv.env }} {{ setenv.value }}
        {%- else  %}
    UnsetEnv {{ setenv.env }}
        {% endif %}
      {%- endfor %}
    {%- endif %}
    {%- if vhost_config.users_apache_env is defined %}
      {%- for setenv in vhost_config.users_apache_env %}
        {%- if ( setenv.set is not defined ) or ( setenv.set is defined and setenv.set ) %}
    SetEnv {{ setenv.env }} {{ setenv.value }}
        {%- else  %}
    UnsetEnv {{ setenv.env }}
        {% endif %}
      {%- endfor %}
    {%- endif %}
  </IfModule>
  {%- endif %}
  {%- if users_apache_set_env_if is defined or vhost_config.users_apache_set_env_if is defined %}
  <IfModule setenvif_module>
    {%- if users_apache_set_env_if is defined %}
      {%- for setenv in users_apache_set_env_if %}
        {%- if setenv.case is not defined or setenv.case is defined and setenv.case %}
    SetEnvIf {{ setenv.attribute }} {{ setenv.regex }} {{ setenv.env }}
        {%- else %}
    SetEnvIfNoCase {{ setenv.attribute }} {{ setenv.regex }} {{ setenv.env }}
        {% endif %}
      {%- endfor %}
    {%- endif %}
    {%- if vhost_config.users_apache_set_env_if is defined %}
      {%- for setenv in vhost_config.users_apache_set_env_if %}
        {%- if setenv.case is not defined or setenv.case is defined and setenv.case %}
    SetEnvIf {{ setenv.attribute }} {{ setenv.regex }} {{ setenv.env }}
        {%- else %}
    SetEnvIfNoCase {{ setenv.attribute }} {{ setenv.regex }} {{ setenv.env }}
        {% endif %}
      {%- endfor %}
    {%- endif %}
  </IfModule>
  {%- endif %}
  <IfModule headers_module>
  {%- if vhost_config.users_apache_headers is defined %}
    {%- for header in vhost_config.users_apache_headers %}
      {% if header.type == "request" %}
    RequestHeader {{ header.action }} {{ header.arg }}
      {% elif header.type == "response" %}
    Header {% if header.con is defined %}{{ header.con }} {% endif %}{{ header.action }} {{ header.expr }}
      {%- endif %}
    {%- endfor %}
  {%- endif %}
  {%- if vhost_config.users_apache_sts is defined %}
    Header always set Strict-Transport-Security "{% for rule in vhost_config.users_apache_sts %}{{ rule }};{% endfor %}"
  {%- else %}
    Header always set Strict-Transport-Security "max-age=31536000"
  {%- endif %}
    Header always set Permissions-Policy "interest-cohort=()"
  </IfModule>
  {%- if vhost_config.users_apache_allow_encoded_slashes is defined %}
  AllowEncodedSlashes {{ vhost_config.users_apache_allow_encoded_slashes }}
  {%- endif %}
  {%- if vhost_config.users_apache_locations is defined -%}
    {%- for loc in vhost_config.users_apache_locations %}
  <Location "{% if loc.location is defined %}{{ loc.location }}{% else %}/{% endif %}" >
      {%- if loc.authtype is defined and loc.authtype == "None" %}
    # No AuthUserFile for this Location as AuthType is None
      {%- elif loc.authtype is not defined and loc.alias is defined %}
    # Alias Location so no AuthUserFile
      {%- elif loc.authtype is not defined and loc.proxy_pass is defined %}
    # ProxyPass Location so no AuthUserFile
      {%- elif loc.authtype is not defined and loc.redirect is defined %}
    # Redirect Location so no AuthUserFile
      {%- else %}
    AuthUserFile "{{ user.value.users_home | default(users_basedir + '/' + user.key) }}/.htpasswd/{{ vhost_config.users_apache_server_name }}"
      {%- endif %}
      {%- if loc.alias is not defined and loc.redirect is not defined and loc.proxy_pass is not defined and loc.proxy_pass_reverse is not defined %}
    AuthName "{% if loc.authname is defined %}{{ loc.authname }}{% else %}Authorised Users{% endif %}"
    AuthType {% if loc.authtype is defined %}{{ loc.authtype }}{% else %}Basic{% endif %}
        {%- if loc.require is defined %}{% for req in loc.require %}
    Require {{ req }}
          {%- endfor %}{% else %}
    Require valid-user
        {%- endif %}
      {%- else %}
        {%- if loc.alias is defined %}
    Alias "{{ loc.alias }}"
        {%- elif loc.proxy_pass is defined %}
    ProxyPass "{{ loc.proxy_pass }}"
          {%- if loc.reverse is defined and loc.reverse | bool %}
    ProxyPassReverse "{{ loc.proxy_pass }}"
          {%- endif %}
        {%- elif loc.redirect is defined %}
    Redirect "{{ loc.redirect }}"
        {%- endif %}
      {%- endif %}
  </Location>
    {%- endfor %}
  {%- endif %}
  <Location "/.well-known/acme-challenge">
    AuthType None
    Require all granted
  </Location>
  {%- if vhost_config.users_apache_robots is defined and vhost_config.users_apache_robots == "deny" %}
    {%- if vhost_config.users_cms is defined and vhost_config.users_cms == "nextcloud" %}
  IncludeOptional /etc/apache2/conf-available/robots-deny-nextcloud.conf
    {%- else %}
  IncludeOptional /etc/apache2/conf-available/robots-deny.conf
    {%- endif %}
  {%- endif %}
  {%- if vhost_config.users_apache_remoteip is defined %}
    {%- if vhost_config.users_apache_remoteip == "cloudflare" %}
  IncludeOptional /etc/apache2/conf-available/cloudflare.conf
    {%- endif %}
  {%- endif %}
  {%- if apache_conf_enabled is defined %}
    {%- if "webarch" in apache_conf_enabled %}
  <Location "/wsh">
    AuthType None
    Require all granted
  </Location>
    {%- elif "mc3" in apache_conf_enabled %}
  <Location "/mc3">
    AuthType None
    Require all granted
  </Location>
    {%- endif %}
  {%- endif %}
  {%- if vhost_config.users_apache_include_optional is defined -%}
    {%- for inc in vhost_config.users_apache_include_optional %}
  IncludeOptional {{ inc }}
    {%- endfor %}
  {%- endif %}
  {%- if vhost_config.users_apache_alias is defined or vhost_config.users_apache_redirects is defined %}
  <IfModule alias_module>
    {%- if vhost_config.users_apache_redirects is defined %}
      {%- for redirect in vhost_config.users_apache_redirects %}
        {%- if redirect.regex_path is defined and redirect.url is defined %}
    RedirectMatch {% if redirect.status is defined %} {{ redirect.status }}{% endif %} "{{ redirect.regex_path }}" "{{ redirect.url }}"
        {%- elif redirect.regex_path is defined and redirect.status is defined and redirect.status is regex('^410|gone$') %}
    RedirectMatch {{ redirect.status }} "{{ redirect.regex_path }}"
        {%- elif redirect.path is defined and redirect.url is defined %}
    Redirect{% if redirect.status is defined %} {{ redirect.status }}{% endif %} "{{ redirect.path }}" "{{ redirect.url }}"
        {%- elif redirect.path is defined and redirect.status is defined and redirect.status is regex('^410|gone$') %}
    Redirect {{ redirect.status }} "{{ redirect.path }}"
        {%- endif %}
      {%- endfor %}
    {%- endif %}
    {%- if vhost_config.users_apache_alias is defined %}
      {%- for alias in vhost_config.users_apache_alias %}
        {%- if alias.url is defined and alias.path is defined %}
    Alias "{{ alias.url }}" "{{ alias.path }}"
        {%- elif alias.regex_url is defined and alias.regex_path is defined %}
    AliasMatch "{{ alias.regex_url }}" "{{ alias.regex_path }}"
        {%- endif %}
      {%- endfor %}
    {%- endif %}
  </IfModule>
  {%- endif %}
  {%- if vhost_config.users_apache_rewrite is defined %}
  <IfModule rewrite_module>
    RewriteEngine on
    {%- for rewrite in vhost_config.users_apache_rewrite %}
      {%- if rewrite.cond is defined %}
    RewriteCond {{ rewrite.cond }}
      {%- endif %}
      {%- if rewrite.rule is defined %}
    RewriteRule {{ rewrite.rule }}
      {%- endif %}
    {%- endfor %}
  </IfModule>
  {%- endif %}
  {%- if "proxy_fcgi" in users_apache_modules_loaded and vhost_config.users_apache_type is defined and vhost_config.users_apache_type == "php" %}
  <IfModule proxy_fcgi_module>
    {%- if user.value.users_groups is defined and "phpfpm" in user.value.users_groups %}
      {%- if "chroot" in user.value.users_groups %}
        {%- if users_apache_chroot is defined and users_apache_chroot %}
    <Proxy "unix:{{ users_apache_chroot_users_basedir }}/{{ user.key }}/php-fpm.sock|fcgi://{{ user.key }}">
          {%- if vhost_config.users_apache_php_proxy_timeout is defined %}
      ProxySet timeout={{ vhost_config.users_apache_php_proxy_timeout }}
          {%- elif user.value.users_apache_php_proxy_timeout is defined %}
      ProxySet timeout={{ user.value.users_apache_php_proxy_timeout }}
          {%- elif users_apache_php_proxy_timeout is defined %}
      ProxySet timeout={{ users_apache_php_proxy_timeout }}
          {%- endif %}
    </Proxy>
        {%- else %}
    <Proxy "unix:{{ users_chroot_users_dir }}/{{ user.key }}{{ user.value.users_home | default(users_basedir + '/' + user.key) }}/php-fpm.sock|fcgi://{{ user.key }}">
          {%- if vhost_config.users_apache_php_proxy_timeout is defined %}
      ProxySet timeout={{ vhost_config.users_apache_php_proxy_timeout }}
          {%- elif user.value.users_apache_php_proxy_timeout is defined %}
      ProxySet timeout={{ user.value.users_apache_php_proxy_timeout }}
          {%- elif users_apache_php_proxy_timeout is defined %}
      ProxySet timeout={{ users_apache_php_proxy_timeout }}
          {%- endif %}
    </Proxy>
        {%- endif %}
      {%- else %}
    <Proxy "unix:{{ user.value.users_home | default(users_basedir + '/' + user.key) }}/php-fpm.sock|fcgi://{{ user.key }}">
        {%- if vhost_config.users_apache_php_proxy_timeout is defined %}
      ProxySet timeout={{ vhost_config.users_apache_php_proxy_timeout }}
        {%- elif user.value.users_apache_php_proxy_timeout is defined %}
      ProxySet timeout={{ user.value.users_apache_php_proxy_timeout }}
        {%- elif users_apache_php_proxy_timeout is defined %}
      ProxySet timeout={{ users_apache_php_proxy_timeout }}
        {%- endif %}
    </Proxy>
      {%- endif %}
    {%- elif users_phpfpm_version is defined %}
    <Proxy "unix:/run/php/php{{ users_phpfpm_version }}-fpm.sock|fcgi://localhost">
        {%- if vhost_config.users_apache_php_proxy_timeout is defined %}
      ProxySet timeout={{ vhost_config.users_apache_php_proxy_timeout }}
        {%- elif user.value.users_apache_php_proxy_timeout is defined %}
      ProxySet timeout={{ user.value.users_apache_php_proxy_timeout }}
        {%- elif users_apache_php_proxy_timeout is defined %}
      ProxySet timeout={{ users_apache_php_proxy_timeout }}
        {%- endif %}
    </Proxy>
    {%- else -%}
    # Something went wrong the users_phpfpm_version variable needs to be
    # set to the PHP version in order for SetHandler path to the socket
    # to be set for the www-data user
    {%- endif %}
  </IfModule>
  {%- endif %}
  {%- if vhost_config.users_apache_directories is defined %}
    {%- if vhost_config.users_apache_directories == [] %}
  # No Directories are defined
     {%- else %}
       {%- for dir,dir_config in vhost_config.users_apache_directories.items() %}
         {%- if users_apache_chroot is defined and users_apache_chroot %}
  <IfFile "{{ users_apache_chroot_users_basedir }}/{{ user.key }}/{{ users_sites_dir }}/{{ dir }}">
    <Directory "{{ users_apache_chroot_users_basedir }}/{{ user.key }}/{{ users_sites_dir }}/{{ dir }}">
         {%- else %}
  <IfFile "{{ user.value.users_home | default(users_basedir + '/' + user.key) }}/{{ users_sites_dir }}/{{ dir }}">
    <Directory "{{ user.value.users_home | default(users_basedir + '/' + user.key) }}/{{ users_sites_dir }}/{{ dir }}">
         {%- endif %}
       {%- if dir_config.users_apache_options is defined %}
      Options{% for option in dir_config.users_apache_options %} {{ option }}{% endfor %}
       {%- else %}
      Options None
       {%- endif %}
       {%- if dir_config.users_apache_index_options is defined %}
      IndexOptions{% for opt in dir_config.users_apache_index_options %} {{ opt }}{% endfor %}
       {%- elif users_apache_index_options is defined %}
      IndexOptions{% for opt in users_apache_index_options %} {{ opt }}{% endfor %}
       {%- endif %}
       {%- if dir_config.users_apache_index_head_insert is defined %}
      IndexHeadInsert "{{ dir_config.users_apache_index_head_insert | regex_replace('[\"]', '\\"') }}"
       {%- elif users_apache_index_head_insert is defined %}
      IndexHeadInsert "{{ users_apache_index_head_insert | regex_replace('[\"]', '\\"') }}"
       {%- endif %}
       {%- if dir_config.users_apache_header_name is defined %}
      HeaderName {{ dir_config.users_apache_header_name }}
       {%- elif users_apache_header_name is defined %}
      HeaderName {{ users_apache_header_name is defined }}
       {%- endif %}
       {%- if dir_config.users_apache_readme_name is defined %}
      ReadmeName {{ dir_config.users_apache_readme_name }}
       {%- elif users_apache_readme_name is defined %}
      ReadmeName {{ users_apache_readme_name is defined }}
       {%- endif %}
       {%- if dir_config.users_apache_ssi_legacy is defined %}
      SSILegacyExprParser {% if dir_config.users_apache_ssi_legacy %}on{% else %}off{% endif %}
       {%- elif users_apache_ssi_legacy is defined %}
      SSILegacyExprParser {% if users_apache_ssi_legacy %}on{% else %}off{% endif %}
       {%- endif %}
       {%- if dir_config.users_apache_ssi_modified is defined %}
      SSILastModified {% if dir_config.users_apache_ssi_modified %}on{% else %}off{% endif %}
       {%- elif users_apache_ssi_modified is defined %}
      SSILastModified {% if users_apache_ssi_modified %}on{% else %}off{% endif %}
       {%- endif %}
       {%- if dir_config.users_apache_index is defined %}
      DirectoryIndex{% for file in dir_config.users_apache_index %} {{ file }}{% endfor %}
       {%- else %}
      DirectoryIndex index.html index.htm
       {%- endif %}
       {%- if dir_config.users_apache_override is defined %}
      AllowOverride{% for option in dir_config.users_apache_override %} {{ option }}{% endfor %}
       {%- else %}
      AllowOverride AuthConfig FileInfo Indexes Limit Options=Indexes,SymLinksIfOwnerMatch,MultiViews,IncludesNOEXEC Nonfatal=All
       {%- endif %}
       {%- if dir_config.users_apache_add_output_filters is defined %}
         {%- for filter in dir_config.users_apache_add_output_filters %}
      AddOutputFilter {{ filter }}
         {%- endfor %}
       {%- endif %}
       {%- if dir_config.users_apache_add_type is defined %}
         {%- for mimetype in dir_config.users_apache_add_type %}
      AddType "{{ mimetype.type }}" .{{ mimetype.ext }}
         {%- endfor %}
       {%- endif %}
       {%- if dir_config.users_apache_filesmatch is defined %}
         {%- for fm in dir_config.users_apache_filesmatch %}
      <FilesMatch "{{ fm.regex }}" >
           {%- if fm.require is defined %}
             {%- for req in fm.require %}
        Require {{ req }}
             {%- endfor %}
           {%- else %}
        Require all denied
           {%- endif %}
      </FilesMatch>
         {%- endfor %}
        {%- endif %}
        {%- if dir_config.users_apache_auth_name is defined %}
      AuthName "{{ dir_config.users_apache_auth_name }}"
        {%- endif %}
        {%- if dir_config.users_apache_auth_type is defined %}
      AuthType "{{ dir_config.users_apache_auth_type }}"
          {%- if dir_config.users_apache_auth_type == "Basic" %}
      AuthUserFile "{{ user.value.users_home | default(users_basedir + '/' + user.key) }}/.htpasswd/{{ vhost.users_apache_server_name }}"
          {%- endif %}
        {%- else %}
      AuthType "None"
        {%- endif %}
        {%- if dir_config.users_apache_require is defined and dir_config.users_apache_require != [] %}
          {%- for req in dir_config.users_apache_require %}
      Require {{ req }}
          {%- endfor %}
        {%- else %}
      Require all granted
        {%- endif %}
        {%- if dir_config.users_apache_expires is defined %}
          {%- if dir_config.users_apache_expires == "medium" %}
      IncludeOptional "/etc/apache2/conf-available/expires-medium.conf"
          {%- elif dir_config.users_apache_expires == "strict" %}
      IncludeOptional "/etc/apache2/conf-available/expires-strict.conf"
          {%- elif dir_config.users_apache_expires == "forever" %}
      IncludeOptional "/etc/apache2/conf-available/expires-forever.conf"
          {%- endif %}
        {%- endif %}
    </Directory>
  </IfFile>
      {%- endfor %}
    {%- endif %}
  {%- endif %}
  {%- if vhost_config.users_apache_vhost_docroot is not defined or vhost_config.users_apache_vhost_docroot %}
    {%- if users_apache_chroot is defined and users_apache_chroot %}
  <IfFile "{{ users_apache_chroot_users_basedir }}/{{ user.key }}/{{ users_sites_dir }}/{{ vhost }}">
    DocumentRoot "{{ users_apache_chroot_users_basedir }}/{{ user.key }}/{{ users_sites_dir }}/{{ vhost }}"
    <Directory "{{ users_apache_chroot_users_basedir }}/{{ user.key }}/{{ users_sites_dir }}/{{ vhost }}">
    {%- else %}
  <IfFile "/var/www/{{ vhost }}">
    DocumentRoot "/var/www/{{ vhost }}"
    <Directory "/var/www/{{ vhost }}">
    {%- endif %}
    {%- if vhost_config.users_apache_options is defined %}
      Options{% for option in vhost_config.users_apache_options %} {{ option }}{% endfor %}
    {%- elif users_apache_options is defined %}
      Options {% for option in users_apache_options %} {{ option }}{% endfor %}
    {%- elif vhost_config.users_apache_type is defined and vhost_config.users_apache_type == "php" %}
      Options -Indexes +SymlinksIfOwnerMatch -MultiViews +IncludesNOEXEC -ExecCGI
    {%- elif vhost_config.users_apache_type is defined and vhost_config.users_apache_type == "cgi" %}
      Options -Indexes +SymlinksIfOwnerMatch -MultiViews +IncludesNOEXEC +ExecCGI
    {%- elif vhost_config.users_apache_type is defined and vhost_config.users_apache_type == "fcgi" %}
      Options -Indexes +SymlinksIfOwnerMatch -MultiViews +IncludesNOEXEC +ExecCGI
    {%- else %}
      Options -Indexes +SymlinksIfOwnerMatch -MultiViews +IncludesNOEXEC -ExecCGI
    {%- endif %}
    {%- if vhost_config.users_apache_index_head_insert is defined %}
      IndexHeadInsert "{{ vhost_config.users_apache_index_head_insert | regex_replace('[\"]', '\\"') }}"
    {%- elif users_apache_index_head_insert is defined %}
      IndexHeadInsert "{{ users_apache_index_head_insert | regex_replace('[\"]', '\\"') }}"
    {%- endif %}
    {%- if vhost_config.users_apache_index_options is defined %}
      IndexOptions{% for opt in vhost_config.users_apache_index_options %} {{ opt }}{% endfor %}
    {%- elif users_apache_index_options is defined %}
      IndexOptions{% for opt in users_apache_index_options %} {{ opt }}{% endfor %}
    {%- endif %}
    {%- if vhost_config.users_apache_header_name is defined %}
      HeaderName {{ vhost_config.users_apache_header_name }}
    {%- elif users_apache_header_name is defined %}
      HeaderName {{ users_apache_header_name is defined }}
    {%- endif %}
    {%- if vhost_config.users_apache_readme_name is defined %}
      ReadmeName {{ vhost_config.users_apache_readme_name }}
    {%- elif users_apache_readme_name is defined %}
      ReadmeName {{ users_apache_readme_name is defined }}
    {%- endif %}
    {%- if vhost_config.users_apache_ssi_legacy is defined %}
      SSILegacyExprParser {% if vhost_config.users_apache_ssi_legacy %}on{% else %}off{% endif %}
    {%- elif users_apache_ssi_legacy is defined %}
      SSILegacyExprParser {% if users_apache_ssi_legacy %}on{% else %}off{% endif %}
    {%- endif %}
    {%- if vhost_config.users_apache_index is defined %}
      DirectoryIndex{% for file in vhost_config.users_apache_index %} {{ file }}{% endfor %}
    {%- elif users_apache_index is defined %}
      DirectoryIndex{% for file in users_apache_index %} {{ file }}{% endfor %}
    {%- elif vhost_config.users_apache_type is defined and vhost_config.users_apache_type == "php" %}
      DirectoryIndex
      {%- if user.value.users_phpfpm_extensions is defined -%}
        {%- for ext in user.value.users_phpfpm_extensions %} index.{{ ext }}{% endfor -%}
      {%- elif users_phpfpm_extensions is defined -%}
        {%- for ext in users_phpfpm_extensions %} index.{{ ext }}{% endfor -%}
      {%- else %} index.php{% endif %} index.html index.htm index.shtml
    {%- elif vhost_config.users_apache_type is defined and vhost_config.users_apache_type == "cgi" %}
      DirectoryIndex
      {%- if user.value.users_cgi_extensions is defined -%}
        {%- for ext in user.value.users_cgi_extensions %} index.{{ ext }}{% endfor -%}
      {%- elif users_cgi_extensions is defined -%}
        {%- for ext in users_cgi_extensions %} index.{{ ext }}{% endfor -%}
      {%- else %} index.cgi{% endif %} index.html index.htm index.shtml
    {%- elif vhost_config.users_apache_type is defined and vhost_config.users_apache_type == "fcgi" %}
      DirectoryIndex
      {%- if user.value.users_cgi_extensions is defined -%}
        {%- for ext in user.value.users_cgi_extensions %} index.{{ ext }}{% endfor -%}
      {%- elif users_cgi_extensions is defined -%}
        {%- for ext in users_cgi_extensions %} index.{{ ext }}{% endfor -%}
      {%- else %} index.cgi{% endif %} index.html index.htm index.shtml
    {%- else %}
      DirectoryIndex index.html index.htm index.shtml
    {%- endif %}
    {%- if vhost_config.users_apache_override is defined %}
      AllowOverride{% for option in vhost_config.users_apache_override %} {{ option }}{% endfor %}
    {%- elif users_apache_override is defined %}
      AllowOverride{% for option in users_apache_override %} {{ option }}{% endfor %}
    {%- elif vhost_config.users_apache_type is defined and vhost_config.users_apache_type == "php" %}
      AllowOverride AuthConfig FileInfo Indexes Limit Options=Indexes,SymLinksIfOwnerMatch,MultiViews,IncludesNOEXEC Nonfatal=All
    {%- elif vhost_config.users_apache_type is defined and vhost_config.users_apache_type == "cgi" %}
      AllowOverride AuthConfig FileInfo Indexes Limit Options=ExecCGI,SymLinksIfOwnerMatch,MultiViews,IncludesNOEXEC Nonfatal=All
    {%- elif vhost_config.users_apache_type is defined and vhost_config.users_apache_type == "fcgi" %}
      AllowOverride AuthConfig FileInfo Indexes Limit Options=ExecCGI,SymLinksIfOwnerMatch,MultiViews,IncludesNOEXEC Nonfatal=All
    {%- else %}
      AllowOverride AuthConfig FileInfo Indexes Limit Options=Indexes,SymLinksIfOwnerMatch,MultiViews,IncludesNOEXEC Nonfatal=All
    {%- endif %}
    {%- if users_apache_add_output_filters is defined %}
      {%- for filter in users_apache_add_output_filters %}
      AddOutputFilter {{ filter }}
      {%- endfor %}
    {%- endif %}
    {%- if vhost_config.users_apache_add_output_filters is defined %}
      {%- for filter in vhost_config.users_apache_add_output_filters %}
      AddOutputFilter {{ filter }}
      {%- endfor %}
    {%- endif %}
    {%- if users_apache_add_type is defined %}
      {%- for mimetype in users_apache_add_type %}
      AddType "{{ mimetype.type }}" .{{ mimetype.ext }}
      {%- endfor %}
    {%- endif %}
    {%- if vhost_config.users_apache_add_type is defined %}
      {%- for mimetype in vhost_config.users_apache_add_type %}
      AddType "{{ mimetype.type }}" .{{ mimetype.ext }}
      {%- endfor %}
    {%- endif %}
    {%- if vhost_config.users_apache_filesmatch is defined %}
      {%- for fm in vhost_config.users_apache_filesmatch %}
      <FilesMatch "{{ fm.regex }}" >
        {%- if fm.require is defined %}
          {%- for req in fm.require %}
        Require {{ req }}
          {%- endfor %}
        {%- else %}
        Require all denied
        {%- endif %}
      </FilesMatch>
      {%- endfor %}
    {%- endif %}
    {%- if "proxy_fcgi" in users_apache_modules_loaded and vhost_config.users_apache_type is defined and vhost_config.users_apache_type == "php" %}
# Removing for now
#    {#- https://wiki.apache.org/httpd/PHP-FPM#Proxy_via_handler #}
#      <IfModule proxy_fcgi_module>
#        <IfModule setenvif_module>
#          SetEnvIfNoCase ^Authorization$ "(.+)" HTTP_AUTHORIZATION=$1
#        </IfModule>
#      {%- if user.value.users_phpfpm_extensions is defined %}
#        <FilesMatch "\.{% for ext in user.value.users_phpfpm_extensions %}{{ ext }}{{ "|" if not loop.last else "" }}{% endfor %}$">
#      {%- elif users_phpfpm_extensions is defined %}
#        <FilesMatch "\.{% for ext in users_phpfpm_extensions %}{{ ext }}{{ "|" if not loop.last else "" }}{% endfor %}$">
#      {%- else %}
#        <FilesMatch "\.php$">
#      {%- endif %}
#          <If "-f %{REQUEST_FILENAME}">
#      {%- if user.value.users_groups is defined and "phpfpm" in user.value.users_groups %}
#            SetHandler "proxy:fcgi://{{ user.key }}"
#      {%- elif users_phpfpm_version is defined %}
#            SetHandler "proxy:fcgi://localhost"
#      {%- endif %}
#          </If>
#        </FilesMatch>
#      </IfModule>
    {%- elif "cgid" in users_apache_modules_loaded and vhost_config.users_apache_type is defined and vhost_config.users_apache_type == "cgi" %}
      <IfModule cgid_module>
        <IfModule setenvif_module>
          SetEnvIfNoCase ^Authorization$ "(.+)" HTTP_AUTHORIZATION=$1
        </IfModule>
        <IfModule mime_module>
      {%- if user.value.users_cgi_extensions is defined %}
          <FilesMatch "\.{% for ext in user.value.users_cgi_extensions %}{{ ext }}{{ "|" if not loop.last else "" }}{% endfor %}$">
            <If "-f %{REQUEST_FILENAME}">
              SetHandler cgi-script
            </If>
          </FilesMatch>
      {%- elif users_cgi_extensions is defined %}
          <FilesMatch "\.{% for ext in users_cgi_extensions %}{{ ext }}{{ "|" if not loop.last else "" }}{% endfor %}$">
            <If "-f %{REQUEST_FILENAME}">
              SetHandler cgi-script
            </If>
          </FilesMatch>
      {%- else %}
          <FilesMatch "\.cgi$">
            <If "-f %{REQUEST_FILENAME}">
              SetHandler cgi-script
            </If>
          </FilesMatch>
      {%- endif %}
        </IfModule>
      </IfModule>
    {%- elif "fcgid" in users_apache_modules_loaded and vhost_config.users_apache_type is defined and vhost_config.users_apache_type == "fcgi" %}
      <IfModule fcgid_module>
        <IfModule setenvif_module>
          SetEnvIfNoCase ^Authorization$ "(.+)" HTTP_AUTHORIZATION=$1
        </IfModule>
        <IfModule mime_module>
      {%- if user.value.users_cgi_extensions is defined %}
          <FilesMatch "\.{% for ext in user.value.users_cgi_extensions %}{{ ext }}{{ "|" if not loop.last else "" }}{% endfor %}$">
            <If "-f %{REQUEST_FILENAME}">
              SetHandler fcgid-script
            </If>
          </FilesMatch>
      {%- elif users_cgi_extensions is defined %}
          <FilesMatch "\.{% for ext in users_cgi_extensions %}{{ ext }}{{ "|" if not loop.last else "" }}{% endfor %}$">
            <If "-f %{REQUEST_FILENAME}">
              SetHandler fcgid-script
            </If>
          </FilesMatch>
      {%- else %}
          <FilesMatch "\.cgi$">
            <If "-f %{REQUEST_FILENAME}">
              SetHandler fcgid-script
            </If>
          </FilesMatch>
      {%- endif %}
        </IfModule>
      </IfModule>
    {%- endif %}
    {%- if vhost_config.users_apache_auth_name is defined %}
      AuthName "{{ vhost_config.users_apache_auth_name }}"
    {%- endif %}
    {%- if vhost_config.users_apache_auth_type is defined %}
      AuthType "{{ vhost_config.users_apache_auth_type }}"
      {%- if vhost_config.users_apache_auth_type == "Basic" %}
      AuthUserFile "{{ user.value.users_home | default(users_basedir + '/' + user.key) }}/.htpasswd/{{ vhost_config.users_apache_server_name }}"
      {%- endif %}
    {%- else %}
      AuthType "None"
    {%- endif %}
    {%- if vhost_config.users_apache_require is defined and vhost_config.users_apache_require != [] %}
      {%- for req in vhost_config.users_apache_require %}
      Require {{ req }}
      {%- endfor %}
    {%- else %}
      Require all granted
    {%- endif %}
    {%- if vhost_config.users_apache_expires is defined %}
      {%- if vhost_config.users_apache_expires == "medium" %}
      IncludeOptional "/etc/apache2/conf-available/expires-medium.conf"
      {%- elif vhost_config.users_apache_expires == "strict" %}
      IncludeOptional "/etc/apache2/conf-available/expires-strict.conf"
      {%- elif vhost_config.users_apache_expires == "forever" %}
      IncludeOptional "/etc/apache2/conf-available/expires-forever.conf"
      {%- endif %}
    {%- endif %}
    </Directory>
  </IfFile>
  {%- endif %}
  {%- if vhost_config.users_apache_type is defined and vhost_config.users_apache_type == "php" and vhost_config.users_apache_nophp_dirs is defined %}
    {%- for dir in vhost_config.users_apache_nophp_dirs %}
  # No PHP allowed in this directory
  <IfFile "{{ user.value.users_home | default(users_basedir + '/' + user.key) }}/{{ users_sites_dir }}/{{ vhost }}/{{ dir }}">
    <Directory "{{ user.value.users_home | default(users_basedir + '/' + user.key) }}/{{ users_sites_dir }}/{{ vhost }}/{{ dir }}">
      {%- if users.value.users_phpfpm_extensions is defined %}
      RemoveHandler {% for ext in users.value.users_phpfpm_extensions %}.{{ ext }}{{ " " if not loop.last else "" }}{% endfor %}
      {%- elif users_phpfpm_extensions is defined %}
      RemoveHandler {% for ext in users_phpfpm_extensions %}.{{ ext }}{{ " " if not loop.last else "" }}{% endfor %}
      {%- else %}
      RemoveHandler .php
      {%- endif %}
      {%- if users.value.users_phpfpm_extensions is defined %}
      <FilesMatch "\.{% for ext in users.value.users_phpfpm_extensions %}{{ ext }}{{ "|" if not loop.last else "" }}{% endfor %}$">
      {%- elif users_phpfpm_extensions is defined %}
      <FilesMatch "\.{% for ext in users_phpfpm_extensions %}{{ ext }}{{ "|" if not loop.last else "" }}{% endfor %}$">
      {%- else %}
      <FilesMatch "\.php$">
      {%- endif %}
      <If "-f %{REQUEST_FILENAME}">
          Require all denied
      </If>
      </FilesMatch>
    </Directory>
  </IfFile>
    {%- endfor %}
  {%- endif %}
  {%- if vhost_config.users_apache_deny_dirs is defined %}
    {%- for dir in vhost_config.users_apache_deny_dirs %}
  # No access allowed for this directory
  <IfFile "/var/www/{{ vhost }}/{{ dir }}">
    <Directory "/var/www/{{ vhost }}/{{ dir }}">
      Require all denied
    </Directory>
  </IfFile>
    {%- endfor %}
  {%- endif %}
  {%- if vhost_config.users_apache_proxy_pass is defined %}
  <IfModule proxy_module>
    # In reverse proxy or gateway configuration, ProxyRequests should be set to Off
    ProxyRequests Off
    # Enable error documents under /wsh to be served rather than proxying error responses
    ProxyErrorOverride On
    {%- if apache_conf_enabled is defined %}
      {%- if "webarch" in apache_conf_enabled %}
    ProxyPass "/wsh/" "!"
      {%- elif "mc3" in apache_conf_enabled %}
    ProxyPass "/mc3/" "!"
      {%- endif %}
    {%- endif %}
    {%- for proxy in vhost_config.users_apache_proxy_pass %}
      {%- if proxy.preserve_host is defined %}
    ProxyPreserveHost {% if proxy.preserve_host %}On{% else %}Off{% endif %}
      {%- endif %}
      {%- if proxy.path is defined and proxy.url is defined %}
    ProxyPass "{{ proxy.path }}" "{{ proxy.url }}"
      {%- endif %}
      {%- if proxy.add_headers is defined %}
    ProxyAddHeaders {% if proxy.add_headers %}On{% else %}Off{% endif %}
      {%- endif %}
      {%- if proxy.pathmatch is defined and proxy.url is defined %}
    ProxyPassMatch "{{ proxy.pathmatch }}" "{{ proxy.url }}"
      {%- endif %}
      {%- if proxy.rewrite_rules is defined and proxy.rewrite_rules != [] %}
    RewriteEngine On
      {%- endif %}
      {%- if proxy.rewrite_conditions is defined %}
        {%- for cond in proxy.rewrite_conditions %}
    RewriteCond {{ cond }}
        {%- endfor %}
      {%- endif %}
      {%- if proxy.rewrite_rules is defined %}
        {%- for rule in proxy.rewrite_rules %}
    RewriteRule {{ rule }}
        {%- endfor %}
      {%- endif %}
      {%- if proxy.reverse is defined and proxy.reverse %}
    ProxyPassReverse "{{ proxy.path }}" "{{ proxy.url | regex_replace('[ ].*$') }}"
      {%- endif %}
      {%- if proxy.htauth is defined and proxy.htauth %}
    <Proxy "{{ proxy.url }}">
      AuthType {% if proxy.authtype is defined %}{{ proxy.authtype }}{% else %}Basic{% endif %}
      AuthName "{% if proxy.authname is defined %}{{ proxy.authname }}{% else %}Authorised Users{% endif %}"
      AuthUserFile "{{ user.value.users_home | default(users_basedir + '/' + user.key) }}/.htpasswd/{{ vhost_config.users_apache_server_name }}"
        {%- if proxy.require is defined %}{% for req in proxy.require %}
      Require {{ req }}
          {%- endfor %}{% else %}
      Require valid-user
        {%- endif %}
    </Proxy>
      {%- endif %}
    {%- endfor %}
  </IfModule>
  {%- endif %}
  {%- if vhost_config.users_apache_error_docs is defined %}
    {%- for doc in vhost_config.users_apache_error_docs %}
  ErrorDocument {{ doc.code }} {{ doc.path }}
    {%- endfor %}
  {%- endif %}
  CustomLog /var/log/apache2/{{ user.key }}_access.log bandwidth
  LogLevel error
  <IfFile {{ user.value.users_home | default(users_basedir + '/' + user.key) }}/logs>
    ErrorLog  {{ user.value.users_home | default(users_basedir + '/' + user.key) }}/logs/apache.error.log
    CustomLog {{ user.value.users_home | default(users_basedir + '/' + user.key) }}/logs/apache.access.log combined
    {% if vhost_config.users_apache_type is defined and vhost_config.users_apache_type == "cgi" %}
    ScriptLog {{ user.value.users_home | default(users_basedir + '/' + user.key) }}/logs/apache.cgi.log
    {%- endif %}
  </IfFile>
</VirtualHost>
{%- endfor %}

# vim: set ft=apache:
